



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java中Base64的加密工具封装</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java中Base64的加密工具封装</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-27 16:16:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Base64加密作为最简单普遍的加密方式（其实只能称为编码方式），应用场景众多比如秘钥，安全证书，也应用在其他的加密方式中或与其他加密方式进行嵌套使用</p>
<p>可以通过引用sun.misc来使用，也可以自己手动封装工具类（不会受第三方改动的影响，我一般采用这个），目前测试，两种加解密结果都一样，具体如下；</p>
<p>（1）直接引用（jdk版本1.8）及测试如下：</p>
<div>
<pre class="prettyprint linenums">package com.mobile.utils;

import sun.misc.BASE64Decoder;<br />
import sun.misc.BASE64Encoder;<br />
import java.io.IOException;

/**<br />
 * Created by Administrator on 2017/10/25.<br />
 */<br />
public class Base64 {

    public static void main(String[] args) throws IOException {<br />
        String content = "程序默认没有bug";<br />
        System.out.println("加密之前：" + content);

        // 加密<br />
        BASE64Encoder encoder = new BASE64Encoder();<br />
        String encode = encoder.encode(content.getBytes());<br />
        System.out.println("加密后的内容：" + encode);

        // 解密<br />
        BASE64Decoder decoder = new BASE64Decoder();<br />
        String decode = new String(decoder.decodeBuffer(encode));<br />
        System.out.println("解密后的内容：" + decode);<br />
    }

}</pre>
</div>
<p>运行结果如下：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1368523/201903/1368523-20190322135708005-546124090.png" /></p>
<p>（2）手动封装Base64工具类及测试如下：</p>
<div>
<pre class="prettyprint linenums">package com.demo.utils;

import java.io.ByteArrayOutputStream;<br />
import java.io.IOException;<br />
import java.io.OutputStream;<br />
import java.io.UnsupportedEncodingException;

/**<br />
 * Created by Administrator on 2017/10/25.<br />
 */<br />
public class Base64 {<br />
    private static final char[] legalChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".toCharArray();

    public static String encode(byte[] data) {<br />
        int start = 0;<br />
        int len = data.length;<br />
        StringBuffer buf = new StringBuffer(data.length * 3 / 2);

        int end = len - 3;<br />
        int i = start;<br />
        int n = 0;

        while (i &lt;= end) {<br />
            int d = ((((int) data[i]) &amp; 0x0ff) &lt;&lt; 16) | ((((int) data[i + 1]) &amp; 0x0ff) &lt;&lt; 8) | (((int) data[i + 2]) &amp; 0x0ff);

            buf.append(legalChars[(d &gt;&gt; 18) &amp; 63]);<br />
            buf.append(legalChars[(d &gt;&gt; 12) &amp; 63]);<br />
            buf.append(legalChars[(d &gt;&gt; 6) &amp; 63]);<br />
            buf.append(legalChars[d &amp; 63]);

            i += 3;

            if (n++ &gt;= 14) {<br />
                n = 0;<br />
                buf.append(" ");<br />
            }<br />
        }

        if (i == start + len - 2) {<br />
            int d = ((((int) data[i]) &amp; 0x0ff) &lt;&lt; 16) | ((((int) data[i + 1]) &amp; 255) &lt;&lt; 8);

            buf.append(legalChars[(d &gt;&gt; 18) &amp; 63]);<br />
            buf.append(legalChars[(d &gt;&gt; 12) &amp; 63]);<br />
            buf.append(legalChars[(d &gt;&gt; 6) &amp; 63]);<br />
            buf.append("=");<br />
        } else if (i == start + len - 1) {<br />
            int d = (((int) data[i]) &amp; 0x0ff) &lt;&lt; 16;

            buf.append(legalChars[(d &gt;&gt; 18) &amp; 63]);<br />
            buf.append(legalChars[(d &gt;&gt; 12) &amp; 63]);<br />
            buf.append("==");<br />
        }

        return buf.toString();<br />
    }

    private static int decode(char c) {<br />
        if (c &gt;= 'A' &amp;&amp; c &lt;= 'Z')<br />
            return ((int) c) - 65;<br />
        else if (c &gt;= 'a' &amp;&amp; c &lt;= 'z')<br />
            return ((int) c) - 97 + 26;<br />
        else if (c &gt;= '0' &amp;&amp; c &lt;= '9')<br />
            return ((int) c) - 48 + 26 + 26;<br />
        else<br />
            switch (c) {<br />
                case '+':<br />
                    return 62;<br />
                case '/':<br />
                    return 63;<br />
                case '=':<br />
                    return 0;<br />
                default:<br />
                    throw new RuntimeException("unexpected code: " + c);<br />
            }<br />
    }

    /**<br />
     * Decodes the given Base64 encoded String to a new byte array. The byte array holding the decoded data is returned.<br />
     */

    public static byte[] decode(String s) {

        ByteArrayOutputStream bos = new ByteArrayOutputStream();<br />
        try {<br />
            decode(s, bos);<br />
        } catch (IOException e) {<br />
            throw new RuntimeException();<br />
        }<br />
        byte[] decodedBytes = bos.toByteArray();<br />
        try {<br />
            bos.close();<br />
            bos = null;<br />
        } catch (IOException ex) {<br />
            System.err.println("Error while decoding BASE64: " + ex.toString());<br />
        }<br />
        return decodedBytes;<br />
    }

    private static void decode(String s, OutputStream os) throws IOException {<br />
        int i = 0;

        int len = s.length();

        while (true) {<br />
            while (i &lt; len &amp;&amp; s.charAt(i) &lt;= ' ')<br />
                i++;

            if (i == len)<br />
                break;

            int tri = (decode(s.charAt(i)) &lt;&lt; 18) + (decode(s.charAt(i + 1)) &lt;&lt; 12) + (decode(s.charAt(i + 2)) &lt;&lt; 6) + (decode(s.charAt(i + 3)));

            os.write((tri &gt;&gt; 16) &amp; 255);<br />
            if (s.charAt(i + 2) == '=')<br />
                break;<br />
            os.write((tri &gt;&gt; 8) &amp; 255);<br />
            if (s.charAt(i + 3) == '=')<br />
                break;<br />
            os.write(tri &amp; 255);

            i += 4;<br />
        }<br />
    }

    public static void main(String[] args) throws UnsupportedEncodingException {<br />
        String content = "程序默认没有bug";<br />
        System.out.println("加密之前：" + content);

        // 加密<br />
        String jiami = Base64.encode(content.getBytes("utf-8"));<br />
        System.out.println("加密后的内容：" + jiami);

        // 解密<br />
        String jiemi = new String(Base64.decode(jiami));<br />
        System.out.println("解密后的内容：" + jiemi);<br />
    }<br />
}</pre>
</div>
<p>测试运行结果：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1368523/201903/1368523-20190322135708005-546124090.png" /></p>
<p>两者加解密结果比较：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1368523/201903/1368523-20190322142518026-1278053177.png" /></p>
<p>两种加解密结果相同</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv1jj1q.html">kettle系列-我的开源kettle管理平台&lbrack;kettle-manager&rsqb;介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqve42o9.html">代码生成工具&mdash;&mdash;Entity Framework Power Tools</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j2jr48.html">ArcMap常用VBA</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnyo438.html">Ant  OOM的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/49577xvq.html">使用NuGet打包并发布至ProGet过程 （打包再次详解）【下篇】</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zzk6v8.html">Qlikview 处理交叉表数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnng16q.html">POJ 1011 Sticks dfs&comma;剪枝 难度&colon;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w0nxoq.html">Jquery操作radio&comma;checkbox&comma;select表单操作实现代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj4lvd9.html">C&sol;C&plus;&plus;中的&amp;amp&semi;&amp;amp&semi;和&vert;&vert;运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjnk1g8.html">JavaFX基础学习之OkHttp&sol;Gson2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jm14x8.html">Flex4 布局 元素index</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjwmj38.html">HTTP请求中的Form Data与Request Payload的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/950od5e8.html">JDBC 初识</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5npy4q.html">Linux之定时任务crond</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j1nk3q.html">dts的pci模块中bus-range和ranges</a>
		</li>
						<li><a href="https://www.batexi.com/a/q251p5oq.html">小程序 login</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jl4enq.html">Ubuntu 14&period;10 下Eclipse操作HBase</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw7nev9.html">天天向上的力量 III（python在pycharm实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko0yv5q.html">&lbrack;2017BUAA软工&rsqb;结对项目-数独程序扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kg5loq.html">NSDictionary 和NSArray 排序（sort）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwvj1oz8.html">常见的hbase jar</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g06peq.html">maven跳过测试编译命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25jrnlq.html">20155312张竞予 Exp1 PC平台逆向破解&lpar;5&rpar;M</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxddngd9.html">uboot中获取dts资源并操作gpio口</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllllpkq.html">openXML写Excel列组合</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wwjnnq.html">win32控制台程序 宽字符与短字符转化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m22l62q.html">ubuntu下file&lowbar;get&lowbar;contents返回空字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyyrwmq.html">Icehouse 创建Instance代码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wwn00q.html">2019-4-29 js学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rrlp28.html">Glibc堆块的向前向后合并与unlink原理机制探究</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
